/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/**
 * @file dist_rose_tree.tpp
 * @brief The implementation of class @a dist_rose_tree, consists of functions
 *        that manipulating the distributed rose trees.
 * @author Kiminori MATSUZAKI
 */

#ifdef __DIST_ROSE_TREE_H__
#ifndef __DIST_ROSE_TREE_TPP__
#define __DIST_ROSE_TREE_TPP__

/* private */
template< typename A >
dist_rose_tree< A >::dist_rose_tree( )
  : btree( NULL )
{
}

/* private */
template< typename A >
dist_rose_tree< A >::dist_rose_tree( dist_tree< A >* btree_ )
  : btree( btree_ )
{
}

/* public */
template< typename A >
dist_rose_tree< A >::~dist_rose_tree( )
{
  if ( btree ) delete btree;
}

/* public, static */
template< typename A >
dist_rose_tree< A >*
dist_rose_tree< A >::read_from_file( const char *filename )
{
  return new dist_rose_tree< A >( dist_tree< A >::read_from_file( filename ) );
}

/* public */
template< typename A >
bool
dist_rose_tree< A >::write_to_file( const char *filename ) const
{
  return btree->write_to_file( filename );
}

/* public */
template< typename A >
void
dist_rose_tree< A >::print( ) const
{
  return btree->print( );
}

/* public */
template< typename A >
void
dist_rose_tree< A >::setroot( const A& val )
{
  btree->setroot( val );
}

#endif // __DIST_ROSE_TREE_TPP__
#endif // __DIST_ROSE_TREE_H__

