/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/**
 * @file node.tpp
 * @brief The implementation of class @a node.
 * @author Kiminori MATSUZAKI
 */

#ifdef __NODE_H__
#ifndef __NODE_TPP__
#define __NODE_TPP__

#include <stdio.h>

////////////////////////////////////////////////////////////////////////
// Constructor and Destructor
template< typename A >
node< A >::node( const A& value_,
		 nodetype_t nodetype_ )
  : nodetype( nodetype_ ),
    left( NULL ),
    right( NULL ),
    parent( NULL ), 
    value( value_ )
{
}

template< typename A >
node< A >::node( )
  : nodetype( node< A >::NORMAL ),
    left( NULL ),
    right( NULL ) ,
    parent( NULL ) //,
  //    value( static_cast< A >( 0 ) )
{
}

template< typename A >
node< A >::~node( )
{
}

////////////////////////////////////////////////////////////////////////
// Access Method
template< typename A >
inline bool
node< A >::isLeaf( ) const
{
  return ( left == NULL && right == NULL );
}

#endif /* __NODE_TPP__ */
#endif /* __NODE_H__ */
