/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/**
 * @file exceptions.h
 * @brief The header for exceptions on distributed list.
 * @author Yoshiki AKASHI (yoshiki@ipl.cs.uec.ac.jp)
 */

#ifndef __EXCEPTIONS_H__
#define __EXCEPTIONS_H__

#include <string>

namespace skeleton {
  struct bad_size {
    int size_a;
    int size_b;
    bad_size(int a, int b) : size_a(a), size_b(b) { }
  };

  struct error {
    int _errno;
    std::string msg;
    error( int errno_ = -1, std::string msg_ = std::string( "" ) )
      : _errno( errno_ ),
	msg( msg_ )
    {
    }
  };
  
}

#endif // __EXCEPTIONS_H__
