/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/***
 * @file fnorm2.cpp
 * @brief The Frobenius Norm(separated source files).  
 * @author Kento EMOTO
 */
#include <cstdlib>
#include <iostream>
#include <cmath>
#include "matrix_skeletons.h"
#include "primitive_functions.h"
using namespace primitive_functions;

double fnorm(const matrix<double> &mat){
	dist_matrix<double> dmat(&mat);
	dist_matrix<double> *dmat2 = matrix_skeletons::map(Square<double>(), &dmat);
	double *ss = matrix_skeletons::reduce(Add<double>(), Add<double>(), dmat2);
	double ret = sqrt(*ss);
	delete ss;
	delete dmat2;
	return ret;
}


