/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/***
 * @file fnormmain.cpp
 * @brief The Frobenius Norm(separated source files).
 * @author Kento EMOTO
 */
#include <cstdlib>
#include <iostream>
#include <cmath>
#include "matrix_skeletons.h"
#include "primitive_functions.h"
using namespace primitive_functions;

double fnorm(const matrix<double> &mat);

int SketoMain( int argc, char **argv )
{
	int n = 1000;
	if(argc > 1){
		n = atoi(argv[1]);
	}
	matrix<double> mat(n, n);
	mat.generate(GenSub<double>());
	double norm = fnorm(mat);
	skeleton::cout << "#procs = "<< skeleton::procs << std::endl;
	skeleton::cout << "matrix size = " << n << "x" << n << std::endl;
	skeleton::cout << "The Frobenius Norm = " << norm << std::endl;
	skeleton::cout << "the matrix = " << std::endl;
	skeleton::cout<< mat<<std::endl;
	return 0;
}
