/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/***
 * @file gen.cpp
 * @brief  Random Matrix generator.  
 * To make an (n x m) matrix, please pass n and m as command line arguments.
 * > gen n m
 * @author Kento EMOTO
 */
#include <iostream>
#include <cstdlib>
#include <ctime>

using namespace std;

void gen(){
	int rs[6];
	for(int i = 0; i < 6; i++){
		for(int j = 0; j < 6; j++){
			rs[j] = j + 1;
		}
		for(int j = 0; j < 5; j++){
			unsigned int x = rand();
			x = x % (6-j);
			cout << rs[x] << " ";
			rs[x] = rs[5-j];
		}
		cout << rs[0] << endl;
	}
}

int main(int argc, char *argv[])
{
	int n = 100;
	int m = 100;
	if(argc > 2){
		n = atoi(argv[1]);
		m = atoi(argv[2]);
	}
	   srand(time(0));
	if(argc < 4) cout << n << " " << m << endl;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < m; j++){
			unsigned int x = rand();
			int y = (x % 21) - 10;
			cout << y << " ";
		}
		cout << endl;
	}
}
